/*
middle_connector object version 1.3
*/


// ======================== middle_object()


function middle_object(){

  this.objprop = '';
  this.refreshtime = 1 * 60 * 1000; // 1 min
  this.eventState = '';
  this.eventTimer = '';  
  this.drawmarker = true;
  this.value = '';
  this.lastvalue = '';
  this.valupdated = '';

  this.valueStr = '';
  
  this.objectToSend = '';
  this.methodToSend = '';
  this.valueToSend = '';
  this.valToSend = -1;
  
  this.scriptToSend = '';
  
  this.fixed = 1;
  

// ------------ init  
  
  this.init = function( ){        
	this.redraw();  
    this.NextEvent(this);   
  }

// ------------ redraw
  
  this.redraw = function(){    
  }
  
// ------------ drawmarker
  
  this.drawmarker = function(){
  }
  
// ------------ GetDirection 
  
  this.GetDirection = function(){
	var mark = '';
	
	if ((this.value != '') && (this.lastvalue != '')){
	  if (this.value > this.lastvalue){
	    mark = '▲';
	  } else {
	    if (this.value < this.lastvalue){
  	      mark = '▼';
	    }
	  }
	}

    return mark; 	  
  }
  
// ------------ NextEventReceived
  
  this.NextEventReceived = function(fobj, data) {
	this.eventState = 'processing';

    var d = data.split('|');
	this.valueStr = d[0];
	
	if (d[0] == '') return false;
	
	this.lastvalue = this.value;
    this.value = Number(d[0]).toFixed(this.fixed);
    this.valupdated = d[1];

	this.eventState = '';
	this.UpdateData(fobj);
	
	this.redraw();
	
	return false;
  }

// ------------ UpdateData
  
  this.UpdateData = function(fobj){    
  }

// ------------ NextEvent
  
  this.NextEvent = function(fobj) {

	// Set next timer
    clearTimeout(fobj.eventTimer);
    fobj.eventTimer = window.setTimeout( function() { 	  
	  fobj.NextEvent( fobj ); 
	}, fobj.refreshtime);
	
    fobj.eventState='requesting';  		
	if (this.drawmarker) fobj.drawmarker();

	// Req data
	var xmlhttp=false;
	if (!xmlhttp && typeof XMLHttpRequest!='undefined') {
	  xmlhttp = new XMLHttpRequest();
	}
	// !!! Путь до getdata скрипта !!!
	xmlhttp.open("GET", '/middle/getdata.php?p='+fobj.objprop, true);
	xmlhttp.onreadystatechange=function() {
	  if (xmlhttp.readyState==4) {
		fobj.NextEventReceived( fobj, xmlhttp.responseText );
	  }
	}
	xmlhttp.send(null);

    return false;
  } // this.NextEvent

// ------------ SendScript [scriptToSend]
  
  this.SendScript = function(fobj) {                
	// Req data
	var xmlhttp = false;
	if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {
	  xmlhttp = new XMLHttpRequest();
	}
	xmlhttp.open("GET", '/objects/?script='+this.scriptToSend, true);
 	xmlhttp.onreadystatechange = function() {
	  if (xmlhttp.readyState == 4) {
		fobj.NextEventReceived(fobj, xmlhttp.responseText);
	  }
	}
	xmlhttp.send(null); 
    return false;
  }

// ------------ SendData [objectToSend, valToSend]

  this.SendData = function(fobj) {                
	// Req data
	var xmlhttp = false;
	if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {
	  xmlhttp = new XMLHttpRequest();
	}
	xmlhttp.open("GET", '/objects/?object='+this.objectToSend+'&op=m&m=update&v='+this.valToSend, true);
 	xmlhttp.onreadystatechange = function() {
	  if (xmlhttp.readyState == 4) {
		fobj.NextEventReceived(fobj, xmlhttp.responseText);
	  }
	}
	xmlhttp.send(null); 
    return false;
  }
  
// ------------ MultiSendData [objectToSend, methodToSend, valueToSend, valToSend]

  this.MultiSendData = function(fobj) {                
	// Req data
	var xmlhttp = false;
	if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {
	  xmlhttp = new XMLHttpRequest();
	}
	xmlhttp.open("GET", '/objects/?object='+this.objectToSend+'&op=m&m='+this.methodToSend+'&'+this.valueToSend+'='+this.valToSend, true);
 	xmlhttp.onreadystatechange = function() {
	  if (xmlhttp.readyState == 4) {
		fobj.NextEventReceived(fobj, xmlhttp.responseText);
	  }
	}
	xmlhttp.send(null); 
    return false;
  }
  
} // middle_object

// ======================== middle_alertobject(objprop, title, refreshtime)


function middle_alertobject(objprop, title, refreshtime, fixed){        
  this.alertmin = -20;
  this.alertmax = 40;
  this.alertTimer = '';
  this.alerttime = 500; // 0.5 sek  
  this.alertstate = 0;  // 0 - off, 1 - on
  this.alertframe = 0;  // Animate frame: 0 - norm, 1 - red

// ------------ UpdateData
  
  this.UpdateData = function(fobj){
    clearTimeout(fobj.alertTimer);
	
	// Range
	fobj.alertstate = (fobj.value < fobj.alertmin) || (fobj.value > fobj.alertmax);
	
	if (fobj.alertstate != 0){
      fobj.alertTimer = window.setTimeout( function() { 	  
	    fobj.NextAlert( fobj ); 
	  }, fobj.alerttime);
	}
	fobj.redraw();
  }  

// ------------ NextAlert 
  
  this.NextAlert = function(fobj) {                
	clearTimeout(fobj.alertTimer);
	
	fobj.alertTimer = window.setTimeout( function() { 	  
	  fobj.NextAlert( fobj ); 
	}, fobj.alerttime);

	fobj.NextAlertFrame(fobj);
	fobj.redraw();
  }

// ------------ NextAlertFrame
  
  this.NextAlertFrame = function(fobj){
    if (fobj.alertstate == 0) { 
	  fobj.alertstate = 1;
	} else {
	  fobj.alertstate = 0;
	}
  }
	
} // middle_alertobject

middle_alertobject.prototype = new middle_object();
